drop procedure DB.DBA.RDF_PROXY_GET_HTTP_HOST;
drop procedure DB.DBA.RDF_SPONGE_IRI_SCH;

set explain on;

create function DB.DBA.RDF_PROXY_GET_HTTP_HOST ()
{
    declare default_host, cname, xhost varchar;
    declare lines any;
    xhost := connection_get ('http_host');
    if (isstring (xhost))
      return xhost;
    lines := http_request_header ();
    if (isvector(lines))
      default_host := http_request_header(lines, 'Host', null, null);
    else if (connection_get ('__http_host') is not null)
        default_host := connection_get ('__http_host');
    else
        default_host := cfg_item_value (virtuoso_ini_path (), 'URIQA', 'DefaultHost');
    if (default_host is not null)
        cname := default_host;
    else
    {
        cname := sys_stat ('st_host_name');
        if (server_http_port () <> '80')
            cname := cname ||':'|| server_http_port ();
    }
    return cname;
}
;

create procedure DB.DBA.RDF_SPONGE_IRI_SCH ()
{
  declare xproto any;
  xproto := connection_get ('http_proto');
  if (isstring (xproto))
    return xproto;
  if (isvector(http_request_header ()) and is_https_ctx ())
    return 'https';
  return 'http';
}
;

set explain off;

grant execute on DB.DBA.RDF_SPONGE_IRI_SCH to public;
grant execute on DB.DBA.RDF_PROXY_GET_HTTP_HOST to public;
